-------------------------------- MODULE gcd --------------------------------

EXTENDS Integers

Divides(p, n) == \E q \in Int : n = q * p

DivisorsOf(n) == {p \in Int : Divides(p, n)}

SetMax(S) == CHOOSE i \in S : \A j \in S : i >= j

GCD(m, n) ==
   SetMax(DivisorsOf(m) \cap DivisorsOf(n))

THEOREM GCD1 == \A m \in Nat \ {0} : GCD(m, m) = m 
  PROOF OMITTED
THEOREM GCD2 == \A m, n \in Nat \ {0} : GCD(m, n) = GCD(n, m) 
  PROOF OMITTED
THEOREM GCD3 == \A m, n \in Nat \ {0} : (n > m) => (GCD(m, n) = GCD(m, n-m)) 
  PROOF OMITTED
   
=============================================================================
\* Modification History
\* Last modified Thu Nov 06 13:15:38 PST 2014 by Chris.Nott
\* Created Thu Nov 06 12:18:54 PST 2014 by Chris.Nott
